C*********************************************************************
C
C     PROGRAM fxsurf
C
C     Ūʿʬ
C
C      1999/11/10 
C
C*********************************************************************
      program taudust
*-----------------------------------------------------
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------

#include "grid_size_M.f"

      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
*-----------------------------------------------------
      integer ibr(nbr3)
*-----------------------------------------------------
      parameter ( day = 86400.0 )
      parameter ( hour = 3600.0 )
      parameter ( PI = 3.241592 )

      dimension
     \   zgrid ( -2:nzb ),
     \   temp0 ( -2:nzb ),
     \   tpot0 ( -2:nzb ),
     \   dens0 ( -2:nzb ),
     \   ppai0 ( -2:nzb ),
     \   pres0 ( -2:nzb ),
     \   rvap0 ( -2:nzb ),
     \   qvap0 ( -2:nzb )

      dimension FDZ(-2:NZB), FDZM(-2:NZB)

      dimension 
     \   QTAU   (-2:NXB,-2:NZB), QDTAU   (-2:NXB,-2:NZB),
     \   QTAUIR1(-2:NXB,-2:NZB), QDTAUIR1(-2:NXB,-2:NZB),
     \   QTAUIR2(-2:NXB,-2:NZB), QDTAUIR2(-2:NXB,-2:NZB)

      dimension
     \     qvap ( -2:nxb, -2:NZB, NROT  )

      real*4 
     \     tau(nx+1),
     \     xplot(nz+1)

      character*2 mint
      character*2 lt
      character*8 ltime

      character*2 date
      character*14 header
      character*100 dumy

*-----------------------------------------------------
      
      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu, times
      read (11,*) ylat, als
      close(11)

      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, zgrid(iz), pres0(iz), dens0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), qvap0(iz), rvap0(iz)
      end do

      call SETGRD
     O   ( ZGRID, FDZ, FDZM, DX,
     D     NZ, NZB                )

      call SETDUST
     O   ( QEXT_SR, QEXT_IR1, QEXT_IR2, 
     O     QALB_SR, QALB_IR1, QALB_IR2, 
     O     QASM_SR, QASM_IR1, QASM_IR2,
     O     QDENS  , QREFF   , QRMOD     )

      if ( time0 == 0.0 ) then
         nloop1 = nloop1 +1
      end if

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv

      call sgpwsn
      read(*,*) iws
      CALL SWISET('IWIDTH',  720)
      CALL SWISET('IHEIGHT', 500)

      call gropn(iws)
      call swlset( 'LALT',  .TRUE. )
      call sglset( 'LFULL', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )
      call uzfact(0.6)

      do ix = 1, nx+1
         xplot(ix) = 0.1 * (ix - 1)
      end do

      do it = 1, nloop1

         read(35) time, ((qvap(ix,iz, 1),ix=-2,nxb), iz=1,nzb)
         write(6,*) 'reading time = ', time

         if ( it .ge. itb   .and.  it .le. ite ) then
            if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(6,*) 'writing time = ', time

            call SETQTAU
     I         ( DENS0, QVAP , 
     I           1 , 
     O           QTAU , QDTAU,
     O           QTAUIR1, QDTAUIR1, QTAUIR2, QDTAUIR2,
     C           QREFF  , QDENS   , QALB   , QASM    , 
     C           QEXT_SR, QEXT_IR1, QEXT_IR2, PI     ,
     G           FDZ  , DX,
     D           NX   , NXB  , NZ   , NZB   , NROT    )

            do IX = 1, NX+1
               tau(ix) = QTAU(ix,0)
            end do

c*** Ѵ: ä LT ************************************
            time = time + times
            write(date,'(I2.2)') INT( time / day ) + 1

            time = ( time - INT( time / day ) * day ) / hour 

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(lt,'(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

            ltime = 'LT=' // lt // ':' // mint
            header = 'day' // date  // ' ' // ltime

c**************************************************************

            call grfrm
            call grswnd ( 0.0, 51.2, 0., 1. )
            call grsvpt ( 0.2, 0.9, 0.25, 0.5 )
            call grstrn (1)
            call grstrf
            call ussttl ( '', 'X[km]', 'Optical Depth', '' )
            call usdaxs
            call uxsttl ( 'T', header, 1. )
            call uulinz ( nx+1, xplot, tau, 1, 3 )

            end if
         end if

      end do

      call grcls

      call FCLOSE

      end
